<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Departments</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">

    <!-- Preloader -->

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Vũ Duy Dũng</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Album</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Album</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Album</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <h3 class="text-center text-primary">Quản trị Album</h3>
          <div class="jumbotron container">
            <div class="row form-group">
              <label for="" class="col-sm-3">Chọn Album</label>
              <div class="col-sm-9">
                <select name="select-department" id="select-department" class="form-control">
                  <option value="none">Chọn Album</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <label for="" class="col-sm-3">Mã Ảnh</label>
              <div class="col-sm-9">
                <input id="inp-employee-code" type="text" class="form-control" placeholder="Mã Ảnh">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Tên Ảnh</label>
              <div class="col-sm-9">
                <input id="inp-employee-name" type="text" class="form-control" placeholder="Tên Ảnh">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Link Ảnh</label>
              <div class="col-sm-9">
                <input id="inp-link" type="text" class="form-control" placeholder="Link Ảnh">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Mô tả</label>
              <div class="col-sm-9">
                <input id="inp-position" type="text" class="form-control" placeholder="Mô tả">
              </div>
            </div>


            <div class="row form-group">
              <label for="" class="col-sm-3">Ngày tạo</label>
              <div class="col-sm-9">
                <input id="inp-date-of-birth" type="date" class="form-control" placeholder="Ngày tạo">
              </div>
            </div>


            <div class="mb-3 d-flex justify-content-around">
              <button id="btn-add" class="btn btn-success"><i class="fas fa-plus"></i>&nbsp;Thêm album</button>
              <button id="btn-update" class="btn btn-primary"><i class="fas fa-users-cog"></i>&nbsp;Cập nhật album</button>
              <button id="btn-delete" class="btn btn-danger"><i class="fas fa-trash"></i>&nbsp;Xóa album</button>
              <button id="btn-delete-all" class="btn btn-danger"><i class="fas fa-trash-alt"></i>&nbsp;Xóa tất cả album</button>
            </div>
            <div class="d-flex justify-content-around">
              <button id="btn-add-employee" class="btn btn-success"><i class="fas fa-user-plus"></i>&nbsp;Thêm ảnh</button>
              <button id="btn-update-employee" class="btn btn-primary"><i class="fas fa-user-edit"></i>&nbsp;Cập nhật
                ảnh</button>
              <button id="btn-delete-employee" class="btn btn-danger"><i class="fas fa-user-times"></i>&nbsp;Xóa ảnh</button>
            </div>


          </div>

          <table id="table-employees" class="table table-bordered table-stripped table-hover">
            <thead>
              <tr>
                <th>STT</th>
                <th>Mã Ảnh</th>
                <th>Tên Ảnh</th>
                <th>Link Ảnh</th>
                <th>Mô tả</th>
                <th>Ngày tạo</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
          <!-- Modal Thêm phòng ban -->
          <div class="modal fade" id="modal-add-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Thêm album</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã album</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên album</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-add" type="text" class="form-control">
                    </div>
                  </div>


                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Mô tả</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-add" type="text" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-add" type="button" class="btn btn-success">Thêm mới</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>

          <!-- Modal cập nhật thông tin phòng ban -->
          <div class="modal fade" id="modal-update-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Cập nhật Album</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã album</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên album</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Mô tả</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-update" type="text" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-update" type="button" class="btn btn-primary">Cập nhật</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
      <!-- /.content -->

      <!-- Modal delete phòng ban -->
      <div class="modal fade" id="modal-delete-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa album này?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal delete tất cả phòng ban -->
      <div class="modal fade" id="modal-delete-all-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn tất cả album?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-all" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal xóa thông tin nhân viên -->
      <div class="modal fade" id="modal-delete-employee" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa hình ảnh này không?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-employee" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gListCol = ["id", "photoCode", "photoName", "linkPhoto", "description", "ngayTao"];
    const gCOL_ID = 0;
    const gCOL_PHOTO_CODE = 1;
    const gCOL_PHOTO_NAME = 2;
    const gCOL_PHOTO_LINK = 3;
    const gCOL_DESCRIPTION = 4;
    const gCOL_NGAY_TAO = 5;

    var gTableEmployee = $("#table-employees").DataTable({
      columns: [
        { data: gListCol[gCOL_ID] },
        { data: gListCol[gCOL_PHOTO_CODE] },
        { data: gListCol[gCOL_PHOTO_NAME] },
        { data: gListCol[gCOL_PHOTO_LINK] },
        { data: gListCol[gCOL_DESCRIPTION] },
        { data: gListCol[gCOL_NGAY_TAO] }
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          render: function () {
            return gStt++;
          }
        }
      ]
    });
    // Biến toàn cục để lưu số thứ tự
    var gStt = 1;
    // Biến lưu id của nhân viên
    var gPhotoId = null;
    // Biến lưu id của phòng ban
    var gAlbumId = null;
    // Biến lưu toàn bộ phòng ban
    var gListDepartment = null;
    // Biến để lưu toàn bộ nhân viên
    var gListPhoto = null;
    // Biến để lưu hành động thực hiện với department
    var gActionAlbum = null;
    // Biến để lưu hành động thực hiện với employee
    var gActionPhoto = null;
    // Biến hành động tạo mới
    const gACTION_CREATE = "create";
    // Biến hành động cập nhật
    const gACTION_UPDATE = "update";


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();

    // Thực thi sự kiện thay đổi phòng ban
    $("#select-department").on("change", function () {
      gAlbumId = $("#select-department").val();
      callApiLoadToLoadListPhotoToTable();
    });

    // Thực thi sự kiện nhấn vào row trong datatable
    $("#table-employees").on("click", "tr", function () {
      onClickTableRow(this);
    });


    // Thực thi sự kiện nhấn nút thêm mới phòng ban
    $("#btn-add").on("click", function () {
      $("#modal-add-department").modal("show");
    });


    // Hàm thực thi sự kiện nhấn nút thêm mới trong modal thêm mới phòng ban
    $("#btn-confirm-add").on("click", function () {
      onBtnCreateNewAlbum();
    });

    // Thực thi sự kiện nhấn nút cập nhật phòng ban
    $("#btn-update").on("click", function () {
      onBtnUpdateDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút confirm update trong modal
    $("#btn-confirm-update").on("click", function () {
      onBtnConfirmUpdateClick();
    });

    // Thực thi sự kiện nhấn nút xóa phòng ban
    $("#btn-delete").on("click", function () {
      onBtnDeleteDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa phòng ban trong modal delete
    $("#btn-confirm-delete").on("click", function () {
      callApiToDeleteAlbum();
    });

    // Thực thi sự kiện nhấn nút xóa tất cả phòng ban
    $("#btn-delete-all").on("click", function () {
      $("#modal-delete-all-department").modal("show");
    });

    // Thực thi sự kiện nhấn nút confirm xóa tất cả phòng ban
    $("#btn-confirm-delete-all").on("click", function () {
      onBtnConfirmDeleteAllAlbumClick();
    });

    // Thực thi sự kiện nhấn nút thêm mới nhân viên
    $("#btn-add-employee").on("click", function () {
      // Kiểm tra xem đã chọn phòng ban chưa
      if (checkSelectAlbum()) {
        onBtnCreateNewPhotoClick();
      }
    });

    // Thực thi sự kiện nhấn nút cập nhật thông tin nhân viên
    $("#btn-update-employee").on("click", function () {
      if (checkSelectAlbum) {
        if (gPhotoId != null) {
          onBtnUpdateEmployeeClick();
        }
        else {
          alert("Vui lòng chọn nhân viên muốn cập nhật thông tin!");
        }
      }
    });

    // Thực thi sự kiện nhấn nút xóa nhân viên
    $("#btn-delete-employee").on("click", function () {
      if (gPhotoId != null) {
        $("#modal-delete-employee").modal("show");
      }
      else {
        alert("Vui lòng chọn nhân viên muốn xóa!");
      }
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa trong modal delete nhân viên
    $("#btn-confirm-delete-employee").on("click", function () {
      onBtnConfirmDeleteEmployeeClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callApiToLoadListAlbumToSelectAlbum();
      callApiToGetListPhoto();
    }

    // Hàm xử lý sự kiện nhấn vào row trong table
    // Khi nhấn vào row thì lấy dữ liệu ra và điền vào form
    function onClickTableRow(paramRow) {
      var vDataRow = gTableEmployee.row(paramRow).data();
      gPhotoId = vDataRow.id;
      // Gọi hàm load dữ liệu row vào form
      loadPhotoDataToForm(vDataRow);
    }

    // Hàm xử lý sự kiện nhấn nút thêm phòng ban trong modal thêm mới
    function onBtnCreateNewAlbum() {
      gActionAlbum = gACTION_CREATE;
      var vNewAlbum = {
        albumCode: "",
        albumName: "",
        description: ""
      }
      // Gọi hàm lấy giá trị insert phòng ban
      getNewAlbumData(vNewAlbum);
      console.log(vNewAlbum);
      // validate dữ liệu
      var vValidate = validateAlbumData(vNewAlbum);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToCreateNewAlbum(vNewAlbum);
      }
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban
    function onBtnUpdateDepartmentClick() {
      if (checkSelectAlbum()) {
        $("#modal-update-department").modal("show");
        callApiToGetAlbumDataById();
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa phòng ban 
    function onBtnDeleteDepartmentClick() {
      if (checkSelectAlbum()) {
        $("#modal-delete-department").modal("show");
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa nhân viên

    // Hàm xử lý sự kiện nhấn nút xác nhận xóa tất cả phòng ban trong modal xóa tất cả
    function onBtnConfirmDeleteAllAlbumClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/albums",
        success: function (paramRes) {
          alert("Tất cả album đã được xóa!");
          $("#modal-delete-all-department").modal("hide");
          callApiToLoadListAlbumToSelectAlbum();
        },
        error: function (paramError) {
          alert("Xóa tất cả album thất bại, vui lòng thử lại!");
          $("#modal-delete-all-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban trong modal
    function onBtnConfirmUpdateClick() {
      gActionAlbum = gACTION_UPDATE;
      var vAlbum = {
        albumCode: "",
        albumName: "",
        description: ""
      }
      // Gọi hàm lấy giá trị phòng ban update
      getDataUpdateAlbum(vAlbum);
      console.log(vAlbum);
      // validate dữ liệu
      var vValidate = validateAlbumData(vAlbum);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToUpdateAlbum(vAlbum);
      }
    }

    // Hàm xử lý sự kiện nhấn nút tạo mới nhân viên
    function onBtnCreateNewPhotoClick() {
      gActionPhoto = gACTION_CREATE;
      var vNewPhoto = {
        photoCode: "",
        photoName: "",
        linkPhoto: "",
        description: "",
      }
      getPhotoDataForm(vNewPhoto);
      console.log(vNewPhoto);
      var vValidate = validatePhotoData(vNewPhoto);
      if (vValidate) {
        callApiToCreateNewPhoto(vNewPhoto);
      }
    }

    // Hàm xử lý sự kiện nhấn nút update nhân viên
    function onBtnUpdateEmployeeClick() {
      gActionPhoto = gACTION_UPDATE;
      var vPhoto = {
        photoCode: "",
        photoName: "",
        linkPhoto: "",
        description: ""
      }
      getPhotoDataForm(vPhoto);
      console.log(vPhoto);
      var vValidate = validatePhotoData(vPhoto);
      if (vValidate) {
        callApiToUpdatePhoto(vPhoto);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa một nhân viên
    function onBtnConfirmDeleteEmployeeClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/photo/" + gPhotoId,
        success: function (paramRes) {
          alert("Xóa hình ảnh thành công!");
          $("#modal-delete-employee").modal("hide");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListPhotoToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListPhoto();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          console.log(paramError.status);
          alert("Xóa hình ảnh thất bại, vui lòng thử lại!");
          $("#modal-delete-employee").modal("hide");
        }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi API để lấy ra danh sách phòng ban đưa vào thẻ select
    function callApiToLoadListAlbumToSelectAlbum() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/albums",
        success: function (paramRes) {
          console.log(paramRes);
          gListDepartment = paramRes;
          loadDataToSelectAlbum(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để lấy danh sách toàn bộ nhân viên
    function callApiToGetListPhoto() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/photos",
        success: function (paramRes) {
          gListPhoto = paramRes;
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào thẻ select Department
    function loadDataToSelectAlbum(paramDataAlbum) {
      var vSelectAlbum = $("#select-department");
      vSelectAlbum.html("");
      $("<option>", {
        value: "none",
        text: "Chọn album"
      }).appendTo(vSelectAlbum);
      for (var bI = 0; bI < paramDataAlbum.length; bI++) {
        $("<option>", {
          value: paramDataAlbum[bI].id,
          text: paramDataAlbum[bI].albumName
        }).appendTo(vSelectAlbum);
      }
    }

    // Hàm call Api load ra danh sách nhân viên khi chọn phòng ban
    function callApiLoadToLoadListPhotoToTable() {
      var vAlbumId = $("#select-department").val();
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/album/" + vAlbumId + "/photos",
        success: function (paramRes) {
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào bảng nhân viên
    function loadDataToTable(paramEmployeeData) {
      gStt = 1;
      gTableEmployee.clear();
      gTableEmployee.rows.add(paramEmployeeData);
      gTableEmployee.draw();
    }

    // Hàm load thông tin nhân viên vào fomr
    function loadPhotoDataToForm(paramPhotoData) {
      $("#inp-employee-code").val(paramPhotoData.photoCode);
      $("#inp-employee-name").val(paramPhotoData.photoName);
      $("#inp-link").val(paramPhotoData.linkPhoto);
      $("#inp-position").prop("value", paramPhotoData.description);
      var vDate = formatDate(paramPhotoData.ngayTao);
      $("#inp-date-of-birth").val(vDate);
    }

    // Hàm chỉnh lại form của ngày tháng cho phù hợp
    function formatDate(paramDate) {
      // tách ra từng phần thông qua hàm split, sau đó sắp xếp theo kiểu của input date là yy-MM-dd"
      var vListDate = paramDate.split("-");
      return vListDate[2] + "-" + vListDate[1] + "-" + vListDate[0];
    }

    // Hàm lấy thông tin phòng ban thêm mới
    function getNewAlbumData(paramDataAlbum) {
      paramDataAlbum.albumCode = $("#inp-department-code-add").val();
      paramDataAlbum.albumName = $("#inp-department-name-add").val();
      paramDataAlbum.description = $("#inp-introduce-add").val();
    }

    // Hàm validate dữ liệu phòng ban
    function validateAlbumData(paramDataAlbum) {
      if (paramDataAlbum.albumCode == "") {
        alert("Vui lòng nhập mã album!");
        return false;
      }
      // Gọi hàm kiểm tra mã phòng ban có tồn tại hay chưa
      if (checkDuplicateAlbumCode(paramDataAlbum.albumCode)) {
        alert("Mã album đã tồn tại!")
        return false;
      }

      if (paramDataAlbum.albumName == "") {
        alert("Vui lòng nhập tên album!");
        return false;
      }

      if (paramDataAlbum.description == "") {
        alert("Vui lòng nhập mô tả album!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để tạo mới 1 phòng ban
    function callApiToCreateNewAlbum(paramDataAlbum) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/albums",
        contentType: "application/json",
        data: JSON.stringify(paramDataAlbum),
        success: function (paramRes) {
          alert("Thêm mới album thành công!");
          callApiToLoadListAlbumToSelectAlbum();
          $("#modal-add-department").modal("hide");
          resetFormCreateNewDepartment();
        },
        error: function (paramError) {
          alert("Tạo mới phòng ban thất bại, vui lòng thử lại");
          $("#modal-add-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm lấy giá trị phòng ban trong modal update
    function getDataUpdateAlbum(paramDataDepartment) {
      paramDataDepartment.albumCode = $("#inp-department-code-update").val().trim();
      paramDataDepartment.albumName = $("#inp-department-name-update").val().trim();
      paramDataDepartment.description = $("#inp-introduce-update").val().trim();
    }

    // Hàm gọi API để lấy dữ liệu phòng ban thông qua ID
    function callApiToGetAlbumDataById() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/album/" + gAlbumId,
        success: function (paramRes) {
          loadAlbumDataToFormUpdate(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      })
    }

    // Hàm load dữ liệu phòng ban vào form update
    function loadAlbumDataToFormUpdate(paramDataAlbum) {
      $("#inp-department-code-update").val(paramDataAlbum.albumCode);
      $("#inp-department-name-update").val(paramDataAlbum.albumName);
      $("#inp-introduce-update").val(paramDataAlbum.description);
    }

    // Hàm gọi API để cập nhật thông tin phòng ban
    function callApiToUpdateAlbum(paramDataAlbum) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/album/" + gAlbumId,
        contentType: "application/json",
        data: JSON.stringify(paramDataAlbum),
        success: function (paramRes) {
          alert("Cập nhật album thành công!");
          callApiToLoadListAlbumToSelectAlbum();
          $("#modal-update-department").modal("hide");
        },
        error: function (paramError) {
          alert("Cập nhật album thất bại, vui lòng thử lại");
          $("#modal-update-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để xóa 1 phòng ban thông qua ID
    function callApiToDeleteAlbum() {
      console.log(gAlbumId);
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/album/" + gAlbumId,
        success: function (paramRes) {
          alert("Xóa album thành công!");
          callApiToLoadListAlbumToSelectAlbum();
          $("#modal-delete-department").modal("hide");
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Xóa album thất bại, vui lòng thử lại");
          $("#modal-delete-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm reset form tạo mới phòng ban
    function resetFormCreateNewDepartment() {
      $("#inp-department-code-add").val("");
      $("#inp-department-name-add").val("");
      $("#inp-major-add").val("");
      $("#inp-introduce-add").val("");
    }

    // Hàm lấy thông tin nhân viên thêm mới
    function getPhotoDataForm(paramEmployeeData) {
      paramEmployeeData.photoCode = $("#inp-employee-code").val().trim();
      paramEmployeeData.photoName = $("#inp-employee-name").val().trim();
      paramEmployeeData.description = $("#inp-position").val().trim();
      paramEmployeeData.linkPhoto = $("#inp-link").val().trim();
    }

    // Hàm kiểm tra đã chọn phòng ban hay chưa
    function checkSelectAlbum() {
      var vDepartmentId = $("#select-department").val();
      if (vDepartmentId == "none") {
        alert("Vui lòng chọn album");
        return false;
      }
      else {
        gAlbumId = vDepartmentId;
        return true;
      }
    }

    // Hàm validate dữ liệu employee
    function validatePhotoData(paramEmployeeData) {
      if (paramEmployeeData.photoCode == "") {
        alert("Vui lòng nhập mã ảnh!");
        return false;
      }
      // Gọi hàm kiểm tra xem mã nhân viên có bị trùng hay không
      if (checkDuplicatePhotoCode(paramEmployeeData.photoCode)) {
        alert("Mã ảnh đã tồn tại!");
        return false;
      }


      if (paramEmployeeData.photoName == "") {
        alert("Vui lòng nhập tên ảnh!");
        return false;
      }
      if (paramEmployeeData.linkPhoto == "") {
        alert("Vui lòng nhập link ảnh!");
        return false;
      }
      if (paramEmployeeData.description == "") {
        alert("Vui lòng nhập mô tả ảnh!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để thêm mới 1 nhân viên
    function callApiToCreateNewPhoto(paramPhotoData) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/album/" + gAlbumId + "/photos",
        contentType: "application/json",
        data: JSON.stringify(paramPhotoData),
        success: function (paramRes) {
          alert("Thêm ảnh thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListPhotoToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListPhoto();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Thêm ảnh thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để cập nhật thông tin 1 nhân viên
    function callApiToUpdatePhoto(paramPhotoData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/album/" + gAlbumId + "/photo/" + gPhotoId,
        contentType: "application/json",
        data: JSON.stringify(paramPhotoData),
        success: function (paramRes) {
          alert("Cập nhật hình ảnh thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListPhotoToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListPhoto();
          // Reset lại form
          resetFormEmployee();

        },
        error: function (paramError) {
          alert("Cập nhật thông tin nhân viên thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm kiểm tra có trùng Department code hay không
    function checkDuplicateAlbumCode(paramDepartmentCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListDepartment.length) {
        if (gListDepartment[vIndex].albumCode == paramDepartmentCode && gActionAlbum == gACTION_CREATE) {
          return true;
        }
        else if(gListDepartment[vIndex].albumCode == paramDepartmentCode && gActionAlbum == gACTION_UPDATE && gListDepartment[vIndex].id != gAlbumId) {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm kiểm tra mã nhân viên đã tồn tại hay chưa
    function checkDuplicatePhotoCode(paramPhotoCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListPhoto.length) {
        // Nếu hành động thực hiện là tạo thì trả về true và có 1 code khác trùng thì trả về true
        if (gListPhoto[vIndex].photoCode == paramPhotoCode && gActionPhoto == gACTION_CREATE) {
          return true;
        }
        // Nếu hành động thực hiện là update mà có 1 code khác trùng nhưng khác vs ID cập nhật thì trả về true 
        else if(gListPhoto[vIndex].photoCode == paramPhotoCode && gActionPhoto == gACTION_UPDATE && gListPhoto[vIndex].id != gPhotoId)
        {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }


    // Hàm reset form employee
    function resetFormEmployee() {
      $("#inp-employee-code").val("");
      $("#inp-employee-name").val("");
      $("#inp-link").val("");
      $("#inp-position").val("");
      $("#inp-date-of-birth").val("");
    }

  </script>
</body>

</html>